/// <reference types="react" />
/// <reference types="styled-jsx" />
import { Omit } from '@material-ui/core';
import { BasePickerProps } from '../../typings/BasePicker';
import { MaterialUiPickersDate } from '../../typings/date';
import { HookOptions } from './usePickerState';
export interface BaseKeyboardPickerProps extends Omit<BasePickerProps, 'onChange'> {
    /** String value for controlling value with pure input string. Overrides value prop */
    inputValue?: string;
    /** Keyboard onChange callback */
    onChange: (date: MaterialUiPickersDate | null, value: string | undefined) => void;
}
export declare function useKeyboardPickerState(props: BaseKeyboardPickerProps, options: HookOptions): {
    inputProps: {
        format: string;
        inputValue: string;
        onChange: (value: string) => void;
        validationError: import("react").ReactNode;
        onClick: () => void;
    };
    wrapperProps: {
        format: string;
        open: boolean;
        onAccept: () => void;
        onClear: () => void;
        onSetToday: () => void;
        onDismiss: () => void;
    };
    pickerProps: {
        date: MaterialUiPickersDate;
        onChange: (newDate: MaterialUiPickersDate, isFinish?: any) => void;
    };
};
