import React from 'react';
import { ModalWrapperProps } from './ModalWrapper';
import { InlineWrapperProps } from './InlineWrapper';
import { Omit } from '@material-ui/core';
import { PureDateInputProps } from '../_shared/PureDateInput';
import { KeyboardDateInputProps } from '../_shared/KeyboardDateInput';
export declare type WrapperVariant = 'dialog' | 'inline';
export interface WrapperProps<T> {
    open: boolean;
    onAccept: () => void;
    onDismiss: () => void;
    onClear: () => void;
    onSetToday: () => void;
    InputComponent: React.FC<T>;
    DateInputProps: T;
    wider?: boolean;
    showTabs?: boolean;
}
declare type OmitInnerWrapperProps<T extends WrapperProps<any>> = Omit<T, keyof WrapperProps<any> | 'showTabs'>;
export declare type ModalRoot = OmitInnerWrapperProps<ModalWrapperProps>;
export declare type InlineRoot = OmitInnerWrapperProps<InlineWrapperProps>;
export declare type ExtendWrapper<TInput extends PureDateInputProps | KeyboardDateInputProps> = {
    /**
     * Displaying variant
     * @default 'dialog'
     */
    variant?: 'dialog' | 'inline';
} & ModalRoot & InlineRoot & Omit<TInput, 'inputValue' | 'onChange' | 'format' | 'validationError' | 'format' | 'forwardedRef'>;
export declare function getWrapperFromVariant<T>(variant?: WrapperVariant): React.ComponentClass<InlineWrapperProps<T> | ModalWrapperProps<T>>;
declare type Props<T> = {
    variant?: WrapperVariant;
    children?: React.ReactChild;
} & (ModalWrapperProps<T> | InlineWrapperProps<T>);
export declare const Wrapper: <T extends KeyboardDateInputProps | PureDateInputProps>(p: Props<T>) => React.ReactElement<Props<T>>;
export {};
